local MAJOR = "StarLibUtils-1.0" 
local MINOR = 1
local LibUtils = LibStub:NewLibrary(MAJOR, MINOR)
if not LibUtils then return end

function LibUtils:resizeText(str, size)
	if strlen(str) < size then
		for i = strlen(str), size do
			str = str .. " "
		end
	end
	return str:sub(1, size)
end

function LibUtils:replaceText(text1, pos1, text2, pos2)
	local char = text2:sub(pos2, pos2)
	
	if char == "" then char = ' ' end
	
	local left = text1:sub(1, pos1 - 1)
	local right = text1:sub(pos1 + 1)
	
	return left .. char .. right
end

function LibUtils:resizeList(tbl, size)
	if #tbl < size then
		for i = #tbl + 1, size do
			tinsert(tbl, " ")
		end
	end
end

function LibUtils:replaceTable(tbl1, pos1, tbl2, pos2)
	
end

function LibUtils:color2RGBA(ev, color, C)
	local e, l
	
    if (color == nil) then
        return -1;
    end
	
	local l = ev.ExecuteCode(self, "color2rgba", color, false, "return 0xffffffff")

    if (strlen(color) == 8) then
        --/* RGBA */
        C.R = self:band(self.rshift(l, 24), 0xff)
        C.G = self:band(self.rshift(l, 16), 0xff)
        C.B = self:band(self.rshift(l, 8), 0xff)
        C.A = self:band(self.rshift(l, 0), 0xff)
    else
        --/* RGB */
        C.R = self:band(self.rshift(l, 16), 0xff)
        C.G = self:band(self.rshift(l, 8), 0xff)
        C.B = self:band(self.rshift(l, 0), 0xff)
        C.A = 0xff
    end
    return 0;
end

function LibUtils:bit(p) 
	return 2 ^ (p - 1) -- 1-based indexing end -- Typical call: if hasbit(x, bit(3)) then ... 
end

function LibUtils:hasbit(x, p) 
	return x % (p + p) >= p 
end 

function LibUtils:setbit(x, p) 
	return hasbit(x, p) and x or x + p 
end 

function LibUtils:clearbit(x, p) 
	return hasbit(x, p) and x - p or x 
end 

function LibUtils:bitor(x, y) 
	local p = 1 
	while p < x do 
		p = p + p 
	end 
	while p < y do 
		p = p + p 
	end 
	local z = 0 
	repeat 
		if p <= x or p <= y then 
			z = z + p 
			if p <= x then 
				x = x - p 
			end 
			if p <= y then 
				y = y - p 
			end 
		end 
		p = p * 0.5 
	until p < 1 

	return z
end

function LibUtils:bitand(x, y)

end

function LibUtils:bitrshift(val, bits)

end

function LibUtils:bitlshift(val, bits)

end

function LibUtils:Memcopy(to, from, size)
	for i = 0, size - 1 do
		to[i] = from[i]
	end
end

  